SD_BUS_IS_OPEN(3)

NAME
sd_bus_is_open, sd_bus_is_ready - Check whether the a bus connection is open or ready.

SYNOPSIS

#include <systemd/sd-bus.h>

int sd_bus_is_open(sd_bus *bus);

int sd_bus_is_ready(sd_bus *bus);

DESCRIPTION

sd_bus_is_open() checks whether the specified bus connection is open, i.e. in the process of being established, already established or in the process of being torn down. It returns zero when the connection has not been started yet (i.e. sd_bus_start(3) or some equivalent call has not been invoked yet), or is fully terminated again (for example after sd_bus_close(3)), it returns positive otherwise.

sd_bus_is_ready() checks whether the specified connection is fully established, i.e. completed the connection and authentication phases of the protocol and received the Hello() method call response, and is not in the process of being torn down again. It returns zero outside of this state, and positive otherwise. Effectively, this function returns positive while regular messages can be sent or received on the connection.

To be notified when the connection is fully established, use sd_bus_set_connected_signal(3) and install a match for the Connected() signal on the "org.freedesktop.DBus.Local" interface. To be notified when the connection is torn down again, install a match for the Disconnected() signal on the "org.freedesktop.DBus.Local" interface.

RETURN VALUE

On success, these functions return 0 or a positive integer. On failure, they return a negative errno-style error code.

ERRORS

Returned errors may indicate the following problems:

-ECHILD
    The bus connection has been created in a different process.

NOTES

These APIs are implemented as a shared library, which can be compiled and linked to with the libsystemd pkg-config(1) file.

SEE ALSO

systemd(1), sd-bus(3), sd_bus_start(3), sd_bus_close(3), sd_bus_set_connected_signal(3)